module AG1_Parser where

import UU_Scanner
import UU_Parsing
import UU_Parsing_ext
import AG1_Sem 

-------------------------------------------------------------------------
-- AG Parser 
-------------------------------------------------------------------------
parser = invokeErr pAG

pAG   = foldl sem_Elems_One_Elem sem_Elems_No_Elem <$> pList pElem

pElem =     sem_Elem_Data     <$-> pKey "DATA"   <*> pConid    <*> pAlts
        <|> sem_Elem_Extend   <$-> pKey "EXTEND" <*> pNonterm  <*> pAlts
        <|> sem_Elem_Indef    <$-> pKey "IN"     <*> pNonterms <*> pAttrs 
        <|> sem_Elem_Outdef   <$-> pKey "OUT"    <*> pNonterms <*> pAttrs 
        <|> sem_Elem_Inoutdef <$-> pKey "INOUT"  <*> pNonterms <*> pAttrs
        <|> sem_Elem_Rules    <$-> pKey "SEM"    <*> pNonterm  <*> pAltRules
        <|> (\s -> (id, id, id, (s:))) <$> pString 
 
pNonterms   =  sem_Nonterms    <$> pbracks_pcommas pNonterm 
pAttrs      =  sem_Attrs       <$> pcommas pVarid  
pNonterm    =  sem_Nonterm     <$> pConid
pAlts       =  sem_Alts        <$> pListPrefixed (pSym '|') pAlt
pAlt        =  sem_Alt         <$> pConid <*>  pFields
pFields     =  sem_Fields      <$> pList pField 
pField      =  sem_Field       <$> pVarid <*-> pSym ':' <*> pConid
  
pAltRules   = pFoldrPrefixed (sem_AltRules_One_AltRule, sem_AltRules_No_AltRules)  (pSym  '|') pAltRule 
pAltRule    = sem_AltRule      <$>  pConid   <*> pFieldRules

pFieldRules = pFoldrPrefixed (sem_FieldRules_One_FieldRule, sem_FieldRules_No_FieldRules) (pSym ',') pFieldRule 
pFieldRule  = sem_FieldRule    <$>  (pVarid  <|> pKey "LOCAL" <|> pKey "LHS") <*> pAttrRules
                                         
pAttrRules  = pFoldrPrefixed (sem_AttrRules_One_AttrRule, sem_AttrRules_No_AttrRules) (pSym ';') pAttrRule 
pAttrRule   = sem_AttrRule     <$>  pVarid   <*-> pSym '=' <*> pString

